## ExtDocument
## Add in changes to PrincipiaSearchSource, toHTML, and toText as needed.  This Python is meant
## to be modified.
##
## Here's a few potential candidates and the tools to convert:
## extension: tool - URL : content_type
## PDF: xPDF - www.foolabs.com/xpdf : application/pdf
## Word: wvWare - www.wvware.com : application/msword
## Word: Try also catdoc - forgot where I found it.
## 

from os import popen
from os.path import join
from Products.ExtFile.ExtFile import ExtFile, TRANSMAP
from Globals import HTMLFile, MessageDialog
import string

converters = {
#                     PrincipiaSearchSource    To Text            To HTML
 'application/pdf': ( 'pdftotext -raw %s -', 'pdftotext %s -', 'pdftotext %s -' ),
 'application/msword': ( 'catdoc -wa %s', 'catdoc -a %s','catdoc -wa %s' )
# 'application/vnd.ms-powerpoint':
}

manage_addExtDocumentForm = HTMLFile('addExtDocumentForm',globals())

def manage_addExtDocument(self, id='', title='', descr='', file='', content_type='', permission_check=0, REQUEST=None):
	"""Add a ExtDocument to a folder."""

	if id=='' and type(file) is not type('') and hasattr(file,'filename'): 
		# generate id from filename and make sure, there are no spaces in the id
		id=file.filename
		id=id[max(string.rfind(id,'/'), 
		          string.rfind(id,'\\'), 
		          string.rfind(id,':')
		         )+1:]
		id=string.translate(id, TRANSMAP)
	if id:
		self=self.this()
		self._setObject(id, ExtDocument(id, title, descr, permission_check))
		self._getOb(id).manage_file_upload(file, content_type)
		self._getOb(id).reindex_object()
		if REQUEST is not None:
			return MessageDialog(title = 'Created',
				message = 'The ExtDocument %s was successfully created!' % id,
				action = './manage_main',)
	elif REQUEST is not None:
		return MessageDialog(title = 'Error!',
			message = 'You must specify a file!', action = './manage_main',)

class ExtDocument(ExtFile):
	"A External Document allows indexing and conversions."
	
	meta_type = 'ExtDocument'

	__ac_permissions__=(
		('View management screens',	('manage_main',
								 'manage_uploadForm')),
		('Change permissions',		('manage_access',)),
		('Change ExtFile/ExtImage',	('manage_editExtFile',
								 'manage_file_upload',
								 'manage_http_upload',
								 'PUT')),
		('FTP access',				('manage_FTPstat',
								 'manage_FTPget',
								 'manage_FTPlist')),
		('Download ExtFile/ExtImage',()),
		('View',					('index_html',
								 'view',
								 'icon_html',
								 'icon_gif',
								 'link',
								 'is_broken',
								 'get_size',
								 'getContentType',
								 'PrincipiaSearchSource',
								 'toText',
								 'toHTML')),
	)	

	def PrincipiaSearchSource(self):
		"""Convert data to raw text (don't bother formatting)"""
		if self.content_type == '' or not converters.has_key(self.content_type):
			return ''
		c = converters[self.content_type]
		if c[0]:
			return popen(c[0] % self._get_filename(self.filename)).read()
		else:
			return ''

	def toText(self):
		"Convert to formatted text"
		if self.content_type == '' or not converters.has_key(self.content_type):
			return ''
		c = converters[self.content_type]
		if c[1]:
			return popen(c[1] % self._get_filename(self.filename)).read()
		else:
			return 'Text conversion is not available for this content type.'

	def toHTML(self):
		"Convert to HTML (if possible)"
		if self.content_type == '' or not converters.has_key(self.content_type):
			return ''
		c = converters[self.content_type]
		if c[1]:
			return popen(c[1] % self._get_filename(self.filename)).read()
		else:
			return 'HTML conversion is not available for this content type.'		
